Liferay.Loader.define("frontend-js-components-web@1.0.27/treeview/NodeListItem", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/icon', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './NodeList', './TreeviewContext', './useFocus', './useKeyboardNavigation'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = NodeListItem;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _NodeList = _interopRequireDefault(require("./NodeList"));

    var _TreeviewContext = _interopRequireDefault(require("./TreeviewContext"));

    var _useFocus = _interopRequireDefault(require("./useFocus"));

    var _useKeyboardNavigation = _interopRequireDefault(require("./useKeyboardNavigation"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function NodeListItem(_ref) {
      var NodeComponent = _ref.NodeComponent,
          node = _ref.node;

      var _useContext = (0, _react.useContext)(_TreeviewContext.default),
          dispatch = _useContext.dispatch,
          state = _useContext.state;

      var onLoadMore = state.onLoadMore;
      var focusable = (0, _useFocus.default)(node.id);
      var handleKeyDown = (0, _useKeyboardNavigation.default)(node.id);
      var children = node.children || [];
      var nodeListItemClassNames = (0, _classnames.default)('lfr-treeview-node-list-item', {
        'with-children': children.length > 0
      });
      var childrenId = "node-list-item-".concat(node.id, "-children");
      var symbol = node.expanded ? 'hr' : 'plus';

      var _useState = (0, _react.useState)(node.paginated),
          _useState2 = _slicedToArray(_useState, 2),
          hasMoreChildren = _useState2[0],
          setHasMoreChildren = _useState2[1];

      var loadMoreItems = (0, _react.useCallback)(function () {
        onLoadMore(node).then(function (response) {
          if (response.items) {
            var items = response.items;
            var alreadyExistingIds = node.children.map(function (item) {
              return item.id;
            });
            var nodesToInsert = Object.values(items).filter(function (item) {
              return !alreadyExistingIds.includes(item.id);
            });

            if (nodesToInsert) {
              dispatch({
                nodeId: node.id,
                nodes: nodesToInsert,
                type: 'INSERT_NODES'
              });
            }

            if (!response.cursor) {
              setHasMoreChildren(false);
            }
          }
        }).catch(function (error) {
          console.error(error);
        });
      }, [dispatch, node, onLoadMore]);

      var toggleExpanded = function toggleExpanded(event) {
        if (node.children.length || node.hasChildren) {
          event.stopPropagation();

          if (onLoadMore && node.hasChildren && !node.expanded && !node.children.length) {
            loadMoreItems(node, onLoadMore, dispatch);
          }

          dispatch({
            nodeId: node.id,
            type: 'TOGGLE_EXPANDED'
          });
        }
      };

      return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
          className: nodeListItemClassNames,
          onBlur: function onBlur() {},
          onClick: function toggleSelected() {
            dispatch({
              nodeId: node.id,
              type: 'TOGGLE_SELECT'
            });
          },
          onDoubleClick: toggleExpanded,
          onKeyDown: handleKeyDown,
          ref: focusable,
          role: "treeitem",
          tabIndex: "-1"
        }, children.length || node.hasChildren ? /*#__PURE__*/_react.default.createElement("button", {
          "aria-controls": childrenId,
          "aria-expanded": node.expanded,
          "aria-label": "".concat(node.expanded ? 'Collapse' : 'Expand', " ").concat(node.name),
          className: "lfr-treeview-node-list-item__button",
          onClick: toggleExpanded,
          tabIndex: "-1",
          type: "button"
        }, /*#__PURE__*/_react.default.createElement(_icon.default, {
          className: "lfr-treeview-node-list-item__button-icon",
          key: symbol,
          symbol: symbol
        })) : null, /*#__PURE__*/_react.default.createElement("div", {
          className: "lfr-treeview-node-list-item__node"
        }, /*#__PURE__*/_react.default.createElement(NodeComponent, {
          node: node
        }))), node.expanded && /*#__PURE__*/_react.default.createElement("div", {
          className: "lfr-treeview-node-list-item__children",
          id: childrenId
        }, /*#__PURE__*/_react.default.createElement(_NodeList.default, {
          NodeComponent: NodeComponent,
          nodes: children
        }), onLoadMore && hasMoreChildren ? /*#__PURE__*/_react.default.createElement(_button.default, {
          className: "mb-5",
          displayType: "secondary",
          onClick: function onClick() {
            return loadMoreItems(node, onLoadMore, dispatch);
          }
        }, Liferay.Language.get('load-more-results')) : null))
      );
    }
    //# sourceMappingURL=NodeListItem.js.map
  }
});
//# sourceMappingURL=NodeListItem.js.map